import java.awt.*;
import java.net.*;
import java.util.StringTokenizer;
import java.util.Date;

public class Banner extends java.applet.Applet implements Runnable {
    Thread thread;
    int speed;
	String	text;
	int		count;
	long	starttime;
    Image	bground, tbground;
	String	fontlist[];
	int		fontnum, fontsize;
	int		nextpos;
	char	banner[];
	int		bwidth;
	boolean	dframe, rtime, ctime, fwd, flicker;
	int		prevw, prevh;
	Image	offimage;
	Color	bcolor, fcolor;
	String	href;
	URL		hrefurl;
	boolean	bground_loaded;
	String	bimage;

    public void init() {
		// Update every 'speed' milliseconds
		String att = getParameter("speed");
		speed = (att == null) ? 400 : Integer.valueOf(att).intValue();

		// URL to go to when the clicking on the applet
		href = getParameter("href");

		// Draw a frame around the banner
		att = getParameter("drawframe");
		dframe = (att == null) ? false : (Integer.valueOf(att).intValue() != 0);

		// Add connected time text to the banner
		att = getParameter("ctime");
		ctime = (att == null) ? false : (Integer.valueOf(att).intValue() != 0);

		// Add time of day text to the banner
		att = getParameter("rtime");
		rtime = (att == null) ? false : (Integer.valueOf(att).intValue() != 0);

		// Direction of the moving text
		att = getParameter("forward");
		fwd = (att == null) ? true : (Integer.valueOf(att).intValue() != 0);

		// Flicker the text
		att = getParameter("flicker");
		flicker = (att == null) ? false : (Integer.valueOf(att).intValue() != 0);

		// Font number to use
		att = getParameter("fontnum");
		fontnum = (att == null) ? 0 : Integer.valueOf(att).intValue();

		// Size of font
		att = getParameter("fontsize");
		fontsize = (att == null) ? 20 : Integer.valueOf(att).intValue();

		// Number of characters to show at one time
		att = getParameter("bwidth");
		bwidth = (att == null) ? 15 : Integer.valueOf(att).intValue();

		// Banner text
		text = ((text = getParameter("text")) == null) ? "Hello" : text;

		// Background color
		att = getParameter("bcolor");
		bcolor = att == null ? null : new Color(Integer.valueOf(att,16).intValue());

		// Font color
		att = getParameter("fcolor");
		fcolor = new Color((att == null) ? 0 : Integer.valueOf(att,16).intValue());

		// Background image
		bimage = getParameter("background");
 		if (bimage == null) bground_loaded = true;			
		else bground_loaded = false;

		starttime = System.currentTimeMillis();
		Toolkit	toolkit = Toolkit.getDefaultToolkit();
		fontlist = toolkit.getFontList();
		banner = new char[bwidth];
		nextpos = -1;
		prevh = prevw = 0;
		offimage = null;
		tbground = null;
    }
    
	public void paint(Graphics g) {
		update(g);
	}
	void drawTiledBground(Graphics g, Dimension d) {
		// If we need to load the background picture
		if (bground == null) {
			bground = getImage(getDocumentBase(), bimage);
			bground_loaded = false;
			g.drawImage(bground, -1000, -1000, this);
		}
		// Wait for the background to be ready
		if (bground_loaded) {
			g.drawImage(tbground, 0, 0, this);
		}
	}
	
	public boolean imageUpdate(Image  img, int  infoflags, int  x, int  y, int  width, int  height)
	{
		if (img == bground) {
			if ((infoflags & ALLBITS) != 0) {
				// Created a tiled background
				Dimension d = size();
				tbground = createImage(d.width, d.height);
				Graphics	tg = tbground.getGraphics();
				int h = bground.getHeight(null);
				int w = bground.getWidth(null);
				int	x1, y1;
				if (w > 0 && h > 0) {
					for (x1 = 0; x1 < d.width; x1 += w) {
						for (y1 = 0; y1 < d.height; y1 += h) {
							int	posx = x1, posy = y1;
							if (posx + w >= d.width) posx = d.width-w;
							if (posy + h >= d.height) posy =d.height-h;
							tg.drawImage(bground, posx, posy, this);
						}
					}
				}
				bground_loaded = true;
			}
		}
		return true;
	}
	public synchronized void update(Graphics g) {
		Dimension d = size();
		if (!flicker) {
			try {
				if (offimage == null || d.width != prevw || d.height != prevh) {
					prevw = d.width;
					prevh = d.height;
					offimage = createImage(d.width, d.height);
				}
				Graphics	offg = offimage.getGraphics();
				offPaint(offg);
				g.drawImage(offimage, 0, 0, this);
			} catch (java.lang.OutOfMemoryError e) {
				System.out.println("Applet Banner ran out of memory");
				System.exit(1);
			}
		} else {
			offPaint(g);
		}
	}
    public boolean mouseEnter(Event evt, int x, int y) {
		if (href != null) showStatus(href);
		return true;
	}
    public boolean mouseExit(Event evt, int x, int y) {
		if (href != null) showStatus(" ");
		return true;
	}
    public boolean mouseUp(Event evt, int x, int y) {
		if (href != null) {
			try
			{
				hrefurl = new URL(href);
			}
			catch(MalformedURLException e)
			{
				System.out.println("Bad URL: "+href);
				hrefurl = null;
			}
			if (hrefurl != null) {
				getAppletContext().showDocument(hrefurl);
			}
		}
		return true;
	}
	synchronized void  offPaint(Graphics g) {
		int x = 0, y = 0;
		Dimension d = size();
		if (bimage == null) {
			bground_loaded = true;
			if (bcolor == null) {
				g.clearRect(0, 0, d.width, d.height);
			} else {
				g.setColor(bcolor);
				g.fillRect(0, 0, d.width, d.height);
			}
		} else {
			drawTiledBground(g, d);
		}
		if (!bground_loaded) return;

		Font font = new java.awt.Font(fontlist[fontnum],Font.PLAIN, fontsize);
		x = 0;
		y = font.getSize();
		g.setColor(fcolor);
		g.setFont(font);
		FontMetrics fm = g.getFontMetrics();

		String thetext = text;
		if (ctime) {
			long tottime = System.currentTimeMillis()-starttime;
			long secs = tottime/1000;
			long mins = secs/60;
			secs = secs%60;
			long tsecs = secs / 10;
			long usecs = secs % 10;
			String	pading = (mins<10) ? "     " : (mins < 100) ? "    " : (mins < 1000) ?
						"   " : (mins < 10000) ? " " : "";
			thetext += " ... Connect time:"+pading+mins+":"+tsecs+""+usecs;
		}
		if (rtime) {
			Date	date = new Date();
			thetext += " ... "+date.toString();
		}
		int	len = thetext.length();
		if (fwd) {
			nextpos--;
			if (nextpos < 0) nextpos = bwidth+len-1;
		} else {
			nextpos = (nextpos+1)%(bwidth+len);
		}
		if (bwidth > len) bwidth = len;
		int	i;
		for (i = 0; i < bwidth; i++) banner[i] = ' ';
		int	from=0, num=0, dest=0;
		from = len-nextpos;
		dest = 0;
		num = bwidth;
		if (nextpos < bwidth) {
			num = nextpos;
		} else if (nextpos > len) {
			dest = nextpos-len;
			num = bwidth-dest;
			from = 0;
		}

		thetext.getChars(from, from+num, banner, dest);

		g.drawChars(banner, 0, bwidth, x, y);
		if (dframe) {
			g.setColor(Color.red);
			g.drawLine(0, 0, d.width-1, 0);
			g.drawLine(d.width-1, 0, d.width-1, d.height-1);
			g.drawLine(d.width-1, d.height-1, 0, d.height-1);
			g.drawLine(0, d.height-1, 0, 0);
		}
	}


    public void start() {
		if (thread == null) {
			thread = new Thread(this);
			thread.start();
		}
    }
    public void stop() {
		thread = null;
    }
    public void run() {
		if (thread != null) {
			while (true) {
				try {
					Thread.currentThread().sleep(speed);
				} catch (InterruptedException e){}
				try {
					if (bground_loaded) repaint();
				} catch (java.lang.OutOfMemoryError e) {
					System.out.println("Applet Banner ran out of memory");
					System.exit(1);
				}
			}
		}
    }
}
